# CLI program that accepts a filepath and deskews a CSV file. It accepts 2 arguments:
# 1. The filepath to the CSV file
# 2. The column name of the column to deskew
import sys
import pandas as pd
import numpy as np
from scipy import stats

def split_package(package_name, l=2):
    return_val = ""
    return_val = package_name
    return_val = return_val.replace("org.", "")
    return_val = return_val.replace("com.", "")
    return_val = return_val.replace("net.", "")
    return_val = return_val.replace("edu.", "")
    return_val = return_val.replace("gov.", "")
    return_val = return_val.replace("mil.", "")
    return_val = return_val.replace("Microsoft.", "")
    return_val = return_val.replace("io.", "")
    sep = "."
    parts = return_val.split(".")
    return sep.join(parts[0:2])
def main(file, col, l=2):
    deskew(file, col, l)

def deskew(file, col, l=2):
    output = "/data/deskewed.csv"
    df = pd.read_csv(file)
    # --- shorten package names
    df["facet"] = df.apply(lambda row: split_package(row.facet,l), axis=1)
    df = df.groupby(['app', 'facet'])['total'].sum().reset_index()
    df.to_csv("temp.csv", index=False)
    print("\nDeskewing column: " + col)
    print("\nCurrent skew....: ", round(df[col].skew(), 4))
    #df[column] = stats.boxcox(df[col])[0]
    df[col] = stats.boxcox(df[col])[0]
    print("\nCorrected skew..: ", round(df[col].skew(), 4))
    df.to_csv(output, index=False)
    print("\nDeskewed file saved to " + output)
