import os.path
import os
import requests
import pandas as pd
import sys, io
import zipfile 
import gzip
import glob


def fetchData(groupFilter):
    COMPASS_CALLBACK_URL = os.getenv("PORTFOLIO_API_URL")
    
    DATA_DIR = "/data"

    GET_URL=f"{COMPASS_CALLBACK_URL}/applicationRepo/records/AIS/zip"
    if (groupFilter is not None): 
        GET_URL=f"{GET_URL}?filterByGroup={groupFilter}"

    print(f"{GET_URL}")
    Filename_csv = "csv.zip"

    print('Downloading started')

    # Downloading the file by sending the request to the URL
    req = requests.get(GET_URL)


    if req.status_code == 200:   
        with open(DATA_DIR+Filename_csv,'wb') as output_file:
            output_file.write(req.content)
        print('Downloading Completed')
    
    # View what is included in the zip file

    #with zipfile.ZipFile(DATA_DIR+Filename_csv, mode="r") as archive:
    # archive.printdir()

        # extract the contents of zip file into the folder 

    with zipfile.ZipFile(DATA_DIR+Filename_csv, 'r') as zip_ref:
        zip_ref.extractall(DATA_DIR)

        # Append all csv file inside a specific path


    #check if the full csv already exist and remove it
    if(os.path.exists(DATA_DIR+"/records/full_file.csv")):
        os.remove(DATA_DIR+"/records/full_file.csv")
    else:
        print("the csv file doesn't exist")

    # Get CSV files list from a folder
    csv_files = glob.glob(DATA_DIR+"/records" + "/*.csv")
    #print(csv_files)
    # Read each CSV file into DataFrame
    # This creates a list of dataframes
    df_list = (pd.read_csv(file) for file in csv_files)

    #print(df_list)
    # Concatenate all DataFrames
    big_df   = pd.concat(df_list, ignore_index=True)
    
    #print (big_df)   
    big_df.to_csv(DATA_DIR+"/records/full_file.csv", sep=',')