from importlib import reload
import find_archetypes
import os
import csai
import pandas as pd
import json
import plotly.express as px
archetypes = reload(find_archetypes)

print ('-------Compass Callback Url-------')
COMPASS_CALLBACK_URL = os.getenv("PORTFOLIO_API_URL")
print(COMPASS_CALLBACK_URL)
print ('-------Parameters-------')
COMPASS_PARAMETERS = os.getenv("PARAMETERS")
print(COMPASS_PARAMETERS)

# Default configuration
metrics = ['euclidean']
epochs = [5000, 10000]
samples = [2,3]
n_neighbors = [2]
min_dists = [.001, .01]
min_clusters = [2]

if COMPASS_PARAMETERS is not None:
    print(COMPASS_PARAMETERS)
    parameters = json.loads(COMPASS_PARAMETERS)
    print(parameters)
    for param in parameters['params']:
        group = param['group']
        prefix = param['clusterNamePrefix']

        if 'metrics' in param: 
            metrics = param['metrics']
        if 'epochs' in param:
            epochs = param['epochs']
        if 'samples' in param:
            samples = param['samples']
        if 'n_neighbors' in param:
            n_neighbors = param['n_neighbors']
        if 'min_dists' in param:
            min_dists = param['min_dists']
        if 'min_clusters' in param:
            min_clusters = param['min_clusters']
        print ("GROUP=>"+group)
        print ("PREFIX=>"+prefix)
        print ("----CLUSTER CONF----")
        print ("METRICS=>")
        print (metrics)
        print ("EPOCHS=>")
        print (epochs)
        print ("SAMPLES=>")
        print (samples)
        print ("N_NEIGHBORS=>")
        print (n_neighbors)
        print ("MIN_DISTS=>")
        print (min_dists)
        print ("MIN_CLUSTERS=>")
        print (min_clusters)
        csai.run (group, prefix,metrics, epochs, samples, n_neighbors, min_dists, min_clusters)
else:
    csai.run ('default', 'prefix', metrics, epochs, samples, n_neighbors, min_dists, min_clusters)



